aboutsummaryrefslogtreecommitdiff
path: root/bin
diff options
context:
space:
mode:
authorDylan Araps <dylan.araps@gmail.com>2026-02-27 13:41:56 +0200
committerDylan Araps <dylan.araps@gmail.com>2026-02-27 13:41:56 +0200
commitda28548905dab7c60c3fcec4975ccfa23e315909 (patch)
tree9cef34a718563969a6bcda5cfeff033eeaf6b1a0 /bin
0.99.0
Diffstat (limited to 'bin')
-rwxr-xr-xbin/dpp76
-rwxr-xr-xbin/u834
2 files changed, 110 insertions, 0 deletions
diff --git a/bin/dpp b/bin/dpp
new file mode 100755
index 0000000..f25c092
--- /dev/null
+++ b/bin/dpp
@@ -0,0 +1,76 @@
+#!/bin/sh -euf
+#
+# DPP - Bonus shell implementation.
+#
+# Copyright (c) 2026 Dylan Araps
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to deal
+# in the Software without restriction, including without limitation the rights
+# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+# copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in all
+# copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+#
+
+: "${DPP_EOF_MARKER:=___DPPEOFMARKER___}"
+: "${DPP_SHELL:=/bin/sh}"
+
+{
+ echo "#!$DPP_SHELL"
+ echo "# This file has been generated by dylanaraps/dpp."
+ echo "(set -euo pipefail 2>/dev/null) && set -eo pipefail || set -eu"
+ echo "export DPP_VERSION=1.0.1"
+ echo "export DPP_LEVEL=\$((DPP_LEVEL + 1))"
+ echo "set -- $*"
+ echo "${DPP_INCLUDE:+. \""$DPP_INCLUDE"\"}"
+
+ while IFS= read -r l; do case $l in
+ "${DPP_BLOCK:=!!}"*)
+ case ${b:-0} in 2)
+ echo "$DPP_EOF_MARKER"
+ b=0
+ esac
+
+ l=${l#"$DPP_BLOCK"}
+
+ case $l in
+ '') b=$((!b)) ;;
+ " "*) b=0 l=${l#?} ;;
+ *) b=0 ;;
+ esac
+
+ echo "$l"
+ ;;
+
+ *)
+ case $l in *\\) l=$l\\; esac
+
+ case ${b:-0} in 0)
+ echo "\${DPP_CAT:=cat} << $DPP_EOF_MARKER"
+ b=2
+ esac
+
+ echo "$l"
+ esac done
+
+ case $b in
+ 1) echo "error: DPP_BLOCK not closed" >&2; exit 1 ;;
+ 2) echo "$DPP_EOF_MARKER" ;;
+ esac
+
+} | case ${0##*/} in
+ dpp-compile) cat ;;
+ *) "$DPP_SHELL" ;;
+esac
+
diff --git a/bin/u8 b/bin/u8
new file mode 100755
index 0000000..c022900
--- /dev/null
+++ b/bin/u8
@@ -0,0 +1,34 @@
+#!/bin/sh -euf
+#
+# Convert input to 32bit hex encoded utf8.
+#
+# Copyright (c) 2026 Dylan Araps
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy
+# of this software and associated documentation files (the "Software"), to deal
+# in the Software without restriction, including without limitation the rights
+# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+# copies of the Software, and to permit persons to whom the Software is
+# furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in all
+# copies or substantial portions of the Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+#
+
+LC_ALL=C
+a=$1 b=${a#?} c=${b#?} d=${c#?}
+a=${a%"$b"} b=${b%"$c"} c=${c%"$d"} d=${d%"${1#????}"}
+export $(printf 'a=%d b=%d c=%d d=%d' "'$a" "'$b" "'$c" "'$d")
+printf '0x%08X\n' "$((a < 128 ? a : a < 224 ?
+(a & 0x1F) << 6 | (b & 0x3F) : a < 240 ?
+(a & 0x0F) << 12 | (b & 0x3F) << 6 | (c & 0x3F) :
+(a & 0x07) << 18 | (b & 0x3F) << 12 | (c & 0x3F) << 6 | (d & 0x3f)))"
+